/**
  ƖRMvO
  PB3(pin15) : PWM(powerLED)
  PD3(pin7)	 : input(recIRmodule)
**/

#include <avr/io.h>
#include <util/delay.h>

#define LIMIT 1300  //HIGHLOW臒l
#define BUF_LENGTH 16
#define ARRAY_LENGTH 11
#define TOP 64999

#define CHECK_BIT_LENGTH 2
#define USERID_BIT_LENGTH 3
#define LIGHTNESS_BIT_LENGTH 4

int powd(int x, int y)
{
	int sum, i;
	if (y == 0)
		return 1;

	sum = x;

	for (i=1; i<=y-1; i++)
		sum=sum*x;

	return(sum);

}

void ms_waiting(int loop){
  int k=0;
  for(k=0; k<loop; k++){
    _delay_ms(1);
  }
}


int receive(int *receiveData){

  int cnt = 0;	//time count
  int dt = 0;	//offonԌvp
  int dataCount = 0;	//receiveData count

  // [_̃`FbNs
  while (bit_is_clear(PIND,PD3)){ 	//_Ԃ̌v
    _delay_us(10);  //10usPʂ
	cnt++;
	if(cnt >= 65535){	//^CAEg
	  cnt = 0;
	  break;
	}
  }
  dt = cnt * 10;

  // [_LȂ珈(2500usonɂĔf)
  if (dt >= 2400 && dt <= 3000) {

    dataCount = 0 ;
    while(bit_is_set(PIND,PD3));	//܂ł[_@offǂݔ΂

    // f[^̓ǂݍ
    while (1){
      while(bit_is_clear(PIND,PD3));  //܂ő҂

      cnt = 0 ;
      while(bit_is_set(PIND,PD3)){   //offԌv
        _delay_us(10) ;  //10usPʂ
        cnt++ ;
        if (cnt >= 1000){	//10000us(12ms)ȏ
          break ;
        }
      }
      dt = cnt * 10;  //off

	  if(dt >= 10000){	//10000us(10ms)ȏȂXgbvf[^
        break;
      }
      if(dt >= LIMIT){	//Limit(1000us)ȏȂ 1
        receiveData[dataCount] = 1;
      }
      else{	        	//Limit(1000us)Ȃ 0
        receiveData[dataCount] = 0;
      }

      dataCount++;
	  if(dataCount >= BUF_LENGTH){
	    dataCount = 0;
		break;
	  }
    }//while(1) end

  }
  return dataCount;
}

//tH[}bg`FbN
int checkFormat(int *receiveData, int length){
  //̊mF
  if (length != ARRAY_LENGTH){
    return -1;
  }
  //f[^̏߂ƏImF
  if((receiveData[0] &
	  receiveData[1] &
	  receiveData[ARRAY_LENGTH-2] &
	  receiveData[ARRAY_LENGTH-1] ) == 1){

		 return 1;
  }
  return -1;
}


//邳߂
int getLightness(int *data){
  int i;
  int start = CHECK_BIT_LENGTH + USERID_BIT_LENGTH; //5
  int end = start + LIGHTNESS_BIT_LENGTH;			//9
  int value = 0;

  //1100->12, 0101->5
  for(i=start; i<end; i++){
    value += data[i] * powd(2, end-1-i);
  }
  return value;
}

int arrayComp(int *data1, const int *data2){
  int i;
  for(i=0; i<ARRAY_LENGTH; i++){
    if(data1[i] != data2[i]){
	  return -1;
	}
  }
  return 1;
}

void arrayReset(int *data){
  int i;
  for(i=0; i<BUF_LENGTH; i++){
    data[i] = 0;
  }
}


// C̏
int main()
{
  int receivedNumber = 0;           //Mf[^
  int receiveData[BUF_LENGTH]={0};  //receive data
  int lightness = 0;                //邳(15`0)
  int pwm_stair = TOP / 15;

  //Light mode
  const int powerOn[ARRAY_LENGTH] = {1, 1, 0, 0, 0, 1, 1, 1, 1, 1, 1}; //userID: [2]~[4]
  const int powerOff[ARRAY_LENGTH]= {1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 1}; //lightness:[5]~[8]

  //|[gݒ
  DDRD  = 0b11110111;  //portD : 3bitڂ̂ݓ
  DDRB  = 0b11111111;  //portB : Sďo
  PORTD = 0b00000000;

  //PWMݒ
  TCCR1A = 0b10000010;  //PWM, cmpA
  TCCR1B = 0b00011001;  //PWM, Ȃ

  ICR1 = TOP; //1/8M * 65000 ms
  OCR1A = 0;  //

  // dA2bԓ_
  PORTD |= (1<<PD2);  	//PD2_
  ms_waiting(2000);
  PORTD &= ~(1<<PD2);	//PD2

  while(1){

	//_܂őҋ@
    while(bit_is_set(PIND,PD3));

    //_MJn
    receivedNumber = receive(receiveData);

	//check format
	if( checkFormat(receiveData, receivedNumber) == 1 ){

	  if( arrayComp(receiveData, powerOn) == 1 ){
		lightness = 15;
	  }
	  else if( arrayComp(receiveData, powerOff) == 1 ){
		lightness = 0;
	  }
	  else{
	    lightness = getLightness(receiveData);
	  }

	  if(lightness < 0)  lightness = 0;
	  if(lightness > 15)  lightness = 15;

	  OCR1A = pwm_stair * lightness;  //light

	  //MM_
	  PORTD |= (1<<PD2);  	//PD2_
      ms_waiting(300);
      PORTD &= ~(1<<PD2);  	//PD2
    }

	//reset
	arrayReset(receiveData);
	receivedNumber = 0;
  }
  // end while(1)

}


